﻿/*
 * Copyright 2019 faddenSoft
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Windows.Media;

namespace SourceGen.Tests {
    /// <summary>
    /// Progress message, with colorful text.  This is generated by the worker thread and
    /// passed to the UI thread.
    /// </summary>
    public class ProgressMessage {
        public string Text { get; private set; }
        public Color Color { get; private set; }
        public bool HasColor { get { return Color.A != 0; } }

        public ProgressMessage(string msg) : this(msg, CommonWPF.Helper.ZeroColor) { }

        public ProgressMessage(string msg, Color color) {
            Text = msg;
            Color = color;
        }
    }
}
